[LeetCode]300. Longest Increasing Subsequence

来源:互联网 发布:ios 判断app网络权限 编辑:程序博客网 时间:2024/05/17 02:40

Given an unsorted array of integers, find the length of longest increasing subsequence.

For example,
Given [10, 9, 2, 5, 3, 7, 101, 18],
The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.

Your algorithm should run in O(n2) complexity.

Follow up: Could you improve it to O(n log n) time complexity?


思路:n2的复杂度,用一个dp存每个元素作为末尾元素的最长序列长度


public class Solution {    public int lengthOfLIS(int[] nums) {        if(nums.length==0){            return 0;        }        int m=1;        int dp[]=new int[nums.length];        dp[0]=1;        for(int i=1;i<nums.length;i++){            int max=0;            for(int j=0;j<i;j++){                if(nums[j]<nums[i]){                    max=Math.max(dp[j],max);                }            }            dp[i]=max+1;            m=Math.max(m,dp[i]);        }        return m;    }}


0 0